package com.tmax.openframe.file;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dataset.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.dataobject.exception.EmptyResultException;
import com.tmax.proobject.dataobject.session.SessionContainer;
import java.math.*;
import java.sql.SQLException;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class TEMPCOB_FD_OUT03 {
    private Long currentSeqId = null;
    private static final int DEFAULT_FETCH_SIZE = 100;
    private TEMPCOB_TEMPCOB_FD_OUT03_Dof dof;
    private @Getter FileStatus fileStatus;
    private Iterator<TEMPCOB_TEMPCOB_FD_OUT03_Do> forwardListIterator_TEMPCOB_FD_OUT03;

    public TEMPCOB_FD_OUT03() {
        dof = new TEMPCOB_TEMPCOB_FD_OUT03_Dof("tibero6_dev");
        forwardListIterator_TEMPCOB_FD_OUT03 = null;
    }

    public void start(Long key) {
        currentSeqId = key;
        dof.setSeq_id(String.valueOf(currentSeqId));
        dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.READ_GE);
        forwardListIterator_TEMPCOB_FD_OUT03 = dof.getForwardList().iterator();
        if (forwardListIterator_TEMPCOB_FD_OUT03.hasNext()) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return;
        }
        fileStatus = FileStatus.NORMAL;
    }

    public TEMPCOB_OUT03 read() {
        if (fileStatus == FileStatus.AT_END_CONDITION_SEQUENCED) {
            fileStatus = FileStatus.ALREADY_AT_END_CONDITION;
            return null;
        }
        TEMPCOB_TEMPCOB_FD_OUT03_Do tmp = null;
        if (forwardListIterator_TEMPCOB_FD_OUT03 != null) {
            if (forwardListIterator_TEMPCOB_FD_OUT03.hasNext()) {
                tmp = forwardListIterator_TEMPCOB_FD_OUT03.next();
                currentSeqId = tmp.getSEQ_ID();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        } else {
            dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.READ_GE);
            dof.setSeq_id(String.valueOf(getNextSeqId()));
            forwardListIterator_TEMPCOB_FD_OUT03 = dof.getForwardList()
                    .iterator();
            if (forwardListIterator_TEMPCOB_FD_OUT03.hasNext()) {
                tmp = forwardListIterator_TEMPCOB_FD_OUT03.next();
                currentSeqId = tmp.getSEQ_ID();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        }
        fileStatus = FileStatus.NORMAL;
        return TEMPCOB_TEMPCOB_FD_OUT03_DoToTEMPCOB_OUT03Mapper.INSTANCE
                .toTEMPCOB_OUT03(tmp);
    }

    public TEMPCOB_OUT03 readNext() {
        return read();
    }

    public TEMPCOB_OUT03 readKey(Long key) {
        currentSeqId = key;
        dof.setSeq_id(String.valueOf(currentSeqId));
        dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.READ_EQ);
        forwardListIterator_TEMPCOB_FD_OUT03 = dof.getForwardList().iterator();
        TEMPCOB_OUT03 record = read();
        if (record == null) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return null;
        }
        return record;
    }

    public void rewrite(TEMPCOB_OUT03 data, Long seq) {
        TEMPCOB_TEMPCOB_FD_OUT03_Do tmpObject = TEMPCOB_TEMPCOB_FD_OUT03_DoToTEMPCOB_OUT03Mapper.INSTANCE
                .toTEMPCOB_TEMPCOB_FD_OUT03_Do(data);
        dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.REWRITE);
        tmpObject.setSEQ_ID(seq);
        try {
            dof.update(tmpObject);
            fileStatus = FileStatus.NORMAL;
        } catch (EmptyResultException ex) {
            fileStatus = FileStatus.INVALID_KEY_CREATE;
        }
    }

    public void rewrite(TEMPCOB_OUT03 data) {
        rewrite(data, currentSeqId);
    }

    public void write(TEMPCOB_OUT03 data) {
        dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.WRITE);
        dof.add(TEMPCOB_TEMPCOB_FD_OUT03_DoToTEMPCOB_OUT03Mapper.INSTANCE
                .toTEMPCOB_TEMPCOB_FD_OUT03_Do(data));
        fileStatus = FileStatus.NORMAL;
    }

    public int delete() {
        return _delete(currentSeqId);
    }

    public int delete(Long key) {
        int cnt = _delete(key);
        if (cnt == 0) {
            fileStatus = FileStatus.INVALID_KEY_READ;
        } else {
            fileStatus = FileStatus.NORMAL;
        }
        return cnt;
    }

    private int _delete(Long key) {
        if (dof == null || forwardListIterator_TEMPCOB_FD_OUT03 == null) {
            return 0;
        }
        dof.setFullQuery(TEMPCOB_TEMPCOB_FD_OUT03_Dof.FULLQUERY.DELETE);
        dof.setSeq_id(String.valueOf(currentSeqId));
        return dof.remove();
    }

    public void close() {
        SessionContainer.getInstance().commit();
        forwardListIterator_TEMPCOB_FD_OUT03 = null;
        currentSeqId = null;
    }

    private Long getNextSeqId() {
        if (currentSeqId != null) {
            currentSeqId++;
        } else {
            currentSeqId = 1L;
        }
        return currentSeqId;
    }
}
